<?php

defined('_JEXEC') or die('Restricted access');
if (!class_exists('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

use Joomla\CMS\Factory;
use Joomla\CMS\Version;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Uri\Uri;

class plgVmPaymentQazaqpay extends vmPSPlugin
{

	public $version = '1.0.0';
	static $IDS = array();
	protected $_isInList = false;
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_loggable = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
		// $this->setConvertable(array('min_amount','max_amount','cost_per_transaction','cost_min_transaction'));
		// $this->setConvertDecimal(array('min_amount','max_amount','cost_per_transaction','cost_min_transaction','cost_percent_total'));
	}

	function getTableSQLFields()
	{
		$SQLfields = array(
			'id' 							=> 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id' 			=> 'int(1) UNSIGNED',
			'order_number'              	=> 'char(64)',
			'virtuemart_paymentmethod_id' 	=> 'mediumint(1) UNSIGNED',
			'payment_name' 					=> 'char(255) NOT NULL DEFAULT \'\' ',
			'payment_order_total'       	=> 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
			'payment_currency' 				=> 'char(3) ',
			'cost_per_transaction' 			=> 'decimal(10,2)',
			'cost_percent_total' 			=> 'char(10)',
			'tax_id' 						=> 'smallint(1)'
		);

		return $SQLfields;
	}

	public function getVmPluginCreateTableSQL()
	{
		return $this->createTableSQL('Qazaqpay Payment Table');
	}

	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id))
			return null;

		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` ' . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($paymentTable = $db->loadObject())) {
			vmWarn(500, $q . " " . $db->getErrorMsg());
			return '';
		}

		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist table">' . "\n";
		$html .= $this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('QAZAPAY_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= '</table>' . "\n";

		return $html;
	}

	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
	{
		return $this->onStoreInstallPluginTable($jplugin_id);
	}

	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
	{
		return $this->OnSelectCheck($cart);
	}

	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
	{
		return $this->displayListFE($cart, $selected, $htmlIn);
	}

	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
	{
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}

	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
	{
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
			return null;

		if (!$this->selectedThisElement($method->payment_element))
			return false;

		$this->getPaymentCurrency($method);

		$paymentCurrencyId = $method->payment_currency;
	}

	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
	{
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}

	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
	{
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}

	function plgVmonShowOrderPrintPayment($order_number, $method_id)
	{
		return $this->onShowOrderPrint($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsPayment($name, $id, &$data)
	{
		return $this->declarePluginParams('payment', $name, $id, $data);
	}

	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
	{
		return $this->setOnTablePluginParams($name, $id, $table);
	}

	function plgVmDeclarePluginParamsPaymentVM3(&$data)
	{
		return $this->declarePluginParams('payment', $data);
	}

	function plgVmConfirmedOrder($cart, $order)
	{
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
			return null;

		if (!$this->selectedThisElement($method->payment_element))
			return false;

		if (!class_exists('VirtueMartModelOrders'))
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');

		if (!class_exists('VirtueMartModelCurrency'))
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');

		$orderTotal = $order['details']['BT']->order_total;
		$order_id = $order['details']['BT']->virtuemart_order_id;
		// $totalInPaymentCurrency = vmPSPlugin::getAmountInCurrency($order['details']['BT']->order_total, $method->payment_currency);

		$token = $this->getGatewayToken($method->gateway_address, $method->gateway_login, $method->gateway_password);
		if ($token == "") return false;

		$webhook_url = JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=vmplg&task=pluginresponsereceived');

		$success_url = Uri::getInstance()->toString();
		$redirect_url = $this->initPayment(
			$method->gateway_address,
			$token,
			$method->virtual_pos_id,
			$method->agent_id,
			$method->payment_type_id,
			$success_url,
			$webhook_url,
			$order['details']['BT']->first_name . ' ' . $order['details']['BT']->last_name,
			$order_id,
			$orderTotal
		);

		$this->_virtuemart_paymentmethod_id      = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['payment_name']                = $method->payment_name;
		$dbValues['order_number']                = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction']        = $method->cost_per_transaction;
		$dbValues['cost_percent_total']          = $method->cost_percent_total;
		$dbValues['payment_currency']            = "KZT";
		// $dbValues['payment_order_total']         = $totalInPaymentCurrency;
		$dbValues['payment_order_total']         = $orderTotal;
		$dbValues['tax_id']                      = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);

		$this->processConfirmedOrderPaymentResponse(true, $cart, $order, $this->template, $method->payment_name, $method->status_pending);
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($redirect_url, FALSE);

		return true;
	}

	public function getGatewayToken($address, $login, $password)
	{
		$body = json_encode(array(
			'login' => $login,
			'password' => $password
		), true);

		$ctp_url = $address . '/api/auth/login';

		$curl = curl_init($ctp_url);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $body);

		$response = curl_exec($curl);
		$curl_error = curl_error($curl);
		$curl_errno = curl_errno($curl);
		curl_close($curl);

		if (!$response) {
			return "";
		}

		$data = json_decode($response, true);

		if (!isset($data["token"])) {
			return "";
		}

		return $data["token"];
	}

	public function initPayment($address, $token, $virtual_pos_id, $agent_id, $payment_type_id, $success_url, $webhook_url, $fullname, $order_id, $amount)
	{
		$body = array(
			"virtual_pos_id" => intval($virtual_pos_id),
			"agent_id" => intval($agent_id),
			"success_url" => $success_url,
			"error_url" => $success_url,
			"notify_url" => $success_url,
			"webhook_url" => $webhook_url,
			"client_info" => array(
				"full_name" => $fullname,
			),
			"bill" => array(
				"bill_id" => intval($order_id),
				"sum" => floatval($amount),
				"currency" => "KZT",
				"claims" => array(
					array(
						"claim_id" => intval($order_id),
						"sum" => floatval($amount),
						"payment_type_id" => intval($payment_type_id),
					)
				)
			)
		);

		$ctp_url = $address . '/api/banks/call_payment_page';

		$curl = curl_init($ctp_url);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER, array(
			'Content-Type: application/json',
			'Authorization: Bearer ' . $token
		));
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($body, true));

		$response = curl_exec($curl);
		$curl_error = curl_error($curl);
		$curl_errno = curl_errno($curl);
		curl_close($curl);

		if (!$response) {
			return "";
		}

		$data = json_decode($response, true);

		if (!isset($data["url"])) {
			return "";
		}

		return $data["url"];
	}

	function plgVmOnPaymentResponseReceived()
	{
		$input = (string) file_get_contents("php://input");
		$data = json_decode($input, true);

		if (!isset($data["billId"])) {
			return;
		}

		$order_id = $data["billId"];

		if (!class_exists('VirtueMartModelOrders'))
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');

		$payment = $this->getDataByOrderId($order_id);
		$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);

		$modelOrder = VmModel::getModel('orders');
		$order = array();
		$order['order_status'] = "F";
		$order['customer_notified'] = 1;

		try {
			$modelOrder->updateStatusForOneOrder($order_id, $order, true);
		} catch (Exception $e) {
			echo $e->getMessage();
			header("HTTP/1.1 200 OK");
			die();
		}
		return true;
	}
}
